/* Beispiel fuer Timer */
/* Countdown laeuft tRest Sekunden und zeigt jede dt-te Sekunde an. 
   Hier: Ansatz mit switch(ch)
*/
#include <conio.h>  //kbhit, getch
#include <stdio.h>  //printf
#include <stdlib.h> //exit
#include <time.h>   //clock, time

#define CR4SEC     //<CR> statt sec
#define MIT_TIME
#define CR   13
#define ESC  27

int main (void)
{ int     ch=0, tRest=30, dt=3;
#ifdef  MIT_TIME
  time_t  tj=0, tTick=0, tBell=0, cps=1;
  time(&tj);
#else   MIT_TIME
  clock_t tj=0, tTick=0, tBell=0, cps=CLOCKS_PER_SEC;
  tj = clock();
#endif  MIT_TIME
  tTick = tj ;
  tBell = tj + tRest*cps;

  do
  { if (_kbhit())
	{ ch = _getch(); printf ("%c\r", ch); 
	} 
    switch (ch)
    { case ESC: exit(1); 

#ifdef  CR4SEC
  	  case CR:  tj += dt*cps;  ch=0;  break;
    }
#else   CR4SEC
    }
#ifdef  MIT_TIME
    time(&tj);
#else   MIT_TIME
	tj=clock();
#endif  MIT_TIME
#endif  CR4SEC

	while (tj >= tTick)
	{ printf ("%70s%5d\r", " ", tRest);
      tRest -= dt;  tTick  += dt*cps;
	}
  }  while (tj < tBell);
  printf("\a"); /*beep*/
  return 0 ;
}
